"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateSchemaUrl = void 0;
var chalk_1 = __importDefault(require("chalk"));
var validateSchemaUrl = function (config) {
    var message = chalk_1.default.bold.redBright("Invalid type for 'schemaUrl' option: expecting an url.\n");
    if (typeof config.schemaUrl !== 'string') {
        throw new Error(message);
    }
    var urlRegex = /^(https?|chrome):\/\/[^\s$.?#].[^\s]*$/;
    if (!urlRegex.test(config.schemaUrl)) {
        throw new Error(message);
    }
    return config.schemaUrl;
};
exports.validateSchemaUrl = validateSchemaUrl;
