"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseGraphqlObject = void 0;
var parse_graphql_field_1 = require("./field-parsing/parse-graphql-field");
var capitalize_1 = require("../../../util/capitalize");
var parseGraphqlObject = function (name, fields) {
    if (!fields) {
        return {
            output: '',
            argsTypes: '',
            argsCount: 0,
            typesObject: {},
            argsTypesObject: {},
        };
    }
    var result = fields.reduce(function (out, field) {
        if (field.args && field.args.length > 0) {
            var outputType = (0, parse_graphql_field_1.parseGraphqlField)(field, true).output;
            var functionDefinition = "".concat(field.name, ": (").concat(field.args
                .map(function (arg) { return (0, parse_graphql_field_1.parseGraphqlField)(arg, true).output; })
                .join(', '), ") =>").concat(outputType === null || outputType === void 0 ? void 0 : outputType.split(':')[1]);
            out.output += "".concat(functionDefinition, "; ");
            var typeName = "".concat((0, capitalize_1.capitalize)(field.name)).concat(name, "Args");
            var properties = field.args
                .map(function (arg) { return (0, parse_graphql_field_1.parseGraphqlField)(arg, true).output; })
                .join(', ');
            out.argsTypes += "export type ".concat(typeName, " = { ").concat(properties, " };\n");
            out.argsCount += 1;
            out.argsTypesObject[typeName] = field.args.reduce(function (acc, arg) {
                var _a;
                return (__assign(__assign({}, acc), (_a = {}, _a[arg.name] = (0, parse_graphql_field_1.parseGraphqlField)(arg, true).type, _a)));
            }, {});
        }
        else {
            var res = (0, parse_graphql_field_1.parseGraphqlField)(field, false);
            out.output += res.output;
            out.typesObject[field.name] = res.type;
        }
        return out;
    }, {
        output: '',
        argsTypes: '',
        argsCount: 0,
        typesObject: {},
        argsTypesObject: {},
    });
    return __assign(__assign({}, result), { output: "export interface ".concat(name, " { ").concat(result.output, "}\n") });
};
exports.parseGraphqlObject = parseGraphqlObject;
